Package org.codehaus.groovy.transform

# Class ASTTransformationCollectorCodeVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.codehaus.groovy.transform.ASTTransformationCollectorCodeVisitor

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class ASTTransformationCollectorCodeVisitor extends ClassCodeVisitorSupport
Walks the AST and collects references to annotations that are annotated themselves by `GroovyASTTransformation`. Each such annotation is added.

This visitor is only intended to be executed once, during the `CompilePhase.SEMANTIC_ANALYSIS` phase of compilation.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ASTTransformationCollectorCodeVisitor(SourceUnit source, GroovyClassLoader transformLoader)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected SourceUnit`
  `getSourceUnit()`
  Provides access to the `SourceUnit` for error reporting during visitation.
  `void`
  `visitAnnotations(AnnotatedNode node)`
  Visits annotations on an `AnnotatedNode`, delegating to `ClassCodeVisitorSupport.visitAnnotation(AnnotationNode)`.
  `void`
  `visitClass(ClassNode classNode)`
  Visits a `ClassNode`, processing its annotations, package, imports, contents, and object initializers.
  `protected void`
  `visitStatementAnnotations(Statement statement)`
  Collects AST transforms from statement-level annotations (e.g.

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Constructor Details

  - ### ASTTransformationCollectorCodeVisitor

    public ASTTransformationCollectorCodeVisitor(SourceUnit source, GroovyClassLoader transformLoader)

- ## Method Details

  - ### getSourceUnit

    protected SourceUnit getSourceUnit()
    Description copied from class: `ClassCodeVisitorSupport`
    Provides access to the `SourceUnit` for error reporting during visitation. Implementations must override this method.
    Specified by:
      `getSourceUnit` in class `ClassCodeVisitorSupport`
    Returns:
      the source unit for this visitor

  - ### visitClass

    public void visitClass(ClassNode classNode)
    Description copied from class: `ClassCodeVisitorSupport`
    Visits a `ClassNode`, processing its annotations, package, imports, contents, and object initializers.
    Specified by:
      `visitClass` in interface `GroovyClassVisitor`
    Overrides:
      `visitClass` in class `ClassCodeVisitorSupport`
    Parameters:
      `classNode` - the class node to visit

  - ### visitAnnotations

    public void visitAnnotations(AnnotatedNode node)
    Description copied from class: `ClassCodeVisitorSupport`
    Visits annotations on an `AnnotatedNode`, delegating to `ClassCodeVisitorSupport.visitAnnotation(AnnotationNode)`.
    Overrides:
      `visitAnnotations` in class `ClassCodeVisitorSupport`
    Parameters:
      `node` - the annotated node containing annotations to visit

  - ### visitStatementAnnotations

    protected void visitStatementAnnotations(Statement statement)
    Collects AST transforms from statement-level annotations (e.g. annotations placed directly on `for`/`while`/`do-while` loop statements).
    Overrides:
      `visitStatementAnnotations` in class `ClassCodeVisitorSupport`
    Parameters:
      `statement` - the loop statement that may have statement-level annotations